

class AlluGameSdk  {

    constructor(sdk){
        this.mGameSdk = sdk;
        AlluGameSdk.inst = this;
        this.minit = false;
    }

    //是不是需要提交广告验证；
    shouldCommitAdInfo(){
        if (this.mADCommitCodeList.length > 0){
            for (var k in this.mADCommitCodeList) {
                var v = this.mADCommitCodeList[k];
                if (v == this.qdcode){
                	TLog.Debug("shouldCommitAdInfo true");
                    return true;
                }
            }
        }
        if (this.mADCommitCodeArea.length > 0){
            let code = Number(this.qdcode);
            if (code > 0){
                for (var k in this.mADCommitCodeArea) {
                    var v = this.mADCommitCodeArea[k]
                    if (code >= v[0] && code <= v[1]){
                    	TLog.Debug("shouldCommitAdInfo true");
                        return true
                    }
                }
            }
        }
        TLog.Debug("shouldCommitAdInfo false");
        return false
    }

    sendHttp(request_url, userdata){
        TLog.Debug("sendHttp request_url", request_url)
        if (this.httpclient == null){
            let netSystem = core.NetSystem.getInstance()
            this.httpclient = netSystem.createHttpClient();
        }

        this.httpclient.send(request_url, this, userdata);
    }

    onHttpResponse(url, data, userData){
        TLog.Debug("onHttpResponse url", url)
    }

    onHttpError(url, userData){
        TLog.Debug("onHttpError url", url)
    }


    initSdk() {
        TLog.Debug("AlluGameSdk::initSdk");
        //$url = $gameUrl."?a=b&openid=".$openId."&openkey=".$openKey."&noice=".$noice."&appid=".$appId."&opensign=".$sign."&sign=".$yixiuMd5Encode."&serverid=".$serverId."&platformid=".$platformId."&platform=".$platform;
        this.mopenid = this.mGameSdk.getFromCmdLine("openid");
        this.mopenkey = this.mGameSdk.getFromCmdLine("openkey");
        this.mtstamp = this.mGameSdk.getFromCmdLine("tstamp");
        this.mappid = this.mGameSdk.getFromCmdLine("appid");
        this.quickkey = this.mGameSdk.getFromCmdLine("quickkey");
        this.qdcode = this.mGameSdk.getStringConfigDef("QD_Code1", "");
        this.mplatform_id = "abc";
        if (this.cheat != true && (this.mopenid == null || this.mopenid.length <= 1)) {
            return false;
        }
        TLog.Debug("this.qdcode")
        TLog.Debug(this.qdcode)
        this.gamelogurl = this.mGameSdk.getStringConfigDef("GameLogUrl", "");


        let codelisttxt = this.mGameSdk.getStringConfigDef("ADCommitCodeList", "");//1293,1294
        if (codelisttxt != null && codelisttxt.length > 3){
            this.mADCommitCodeList = codelisttxt.split(',')
        }else{
            this.mADCommitCodeList = []
        }
        TLog.Debug("this.mADCommitCodeList")
        TLog.Debug(this.mADCommitCodeList)
        let codeareatxt = this.mGameSdk.getStringConfigDef("ADCommitCodeArea", "");//1293,1294,1296,1300 areamin1,areamax1, areamin2,areamax2
        this.mADCommitCodeArea = []
        if (codelisttxt != null && codelisttxt.length > 3){
            let arealist = codelisttxt.split(',')
            let num = Math.floor(arealist.length /2)
            for (let i = 0; i < num; ++i){
                let one = arealist[i*2];
                let two = arealist[i*2 + 1];
                let area = [Number(one), Number[two]]
                JsUtil.arrayPush(this.mADCommitCodeArea, area)
            }
        }
        //TLog.Debug("this.mADCommitCodeArea")
        //TLog.Debug(this.mADCommitCodeArea)

        this.minit = true;
        allusdk_init(null, null, null, null)

        TLog.Debug("AlluGameSdk::initSdk end");
        return true;
    }

    // _payCallback(result) {
    //     this.payCallback(result);
    // }

    showShare(params) {
        // if (this.minit != true) {
        //     return false;
        // }
        // if (this.cheat){
        //     return true
        // }
        // allusdk_showShare();
        return true
    }

    showAttention(params){
        // if (this.minit != true) {
        //     return false;
        // }
        // if (this.cheat){
        //     return true
        // }
        // allusdk_showSDKQrCode();
        return true;
    }

    payCallback(result) {
        //res:状态码 -1失败 0取消 1成功
        if (result == 1) {
            this.mGameSdk.onPayReturn(0, "ok");
        } else if (result == 0) {
            this.mGameSdk.onPayReturn(-2, "cancel");
        } else {
            this.mGameSdk.onPayReturn(-3, "error code:" + result);
        }
    }


    login(params){
        console.log("GameSdk.login");
        let openid = this.mGameSdk.getFromCmdLine("openid");
				let tstamp = this.mGameSdk.getFromCmdLine("tstamp");
        let openkey = this.mGameSdk.getFromCmdLine("openkey");
        let pkSign = this.mGameSdk.getFromCmdLine("pkSign");

        let loginInfo = {}
        loginInfo.openid = openid;
        loginInfo.tstamp = tstamp;
        loginInfo.loginKey = openkey;
        loginInfo.code1 = this.mappid;
        loginInfo.quickkey = this.quickkey;
        loginInfo.channeltype = this.channeltype;
        loginInfo.pkSign = pkSign;
        console.log("loginInfo", loginInfo);
        let paramsStr = core.GameSdkUtil.httpParamsToString(loginInfo)

        this.mGameSdk.onLoginReturn(0, paramsStr);
        console.log("GameSdk.login onLoginReturn");
        return true;
    }

    pay(itemparams) {
        console.log("pay");
        console.log(itemparams);
        if (this.minit != true) {
            return false;
        }

        let paramlist = core.GameSdkUtil.splitHttpParams(itemparams);
        //let payParams = "title="+title+"&acctType="+title+"&saveValue="+saveValue+"&payMoney="+ rechargeAdd + "&zoneId=" + zoneId + "&roleId=" + roleId + "&itemId=" + itemid
        //payParams = payParams + "&roleName="+"blank" + "&roleLevel="+roleLevel + "&roleMission="+roleMission
        //payParams = payParams + "&accountId="+accountId
        //payParams = payParams + "&thirdPayLevel="+thirdPayLevel //google商店下，开启第三方支付的等级
        //payParams = payParams + "&isItemShop="+isItemShop //是否月卡

        let itemname = paramlist['title'];
        let amount = core.GameSdkUtil.toNumber(paramlist['payMoney']);
        let itemid = paramlist['itemId'];
        let itemidint = core.GameSdkUtil.toNumber(itemid);
        let groupId = paramlist['groupId'];
        let serverId = paramlist['serverId'];//sdk回报的是服ID
        let curtime = core.GameSdkUtil.getOSTime();
        let roleName = "abc";//Base64Util.encode()
        let cpmsg = paramlist['itemId'] + "_" + paramlist['zoneId'] + "_" + paramlist['roleId'] + "_" + groupId + "_" + curtime + "_" + paramlist['roleLevel'] + "_" + paramlist['roleMission'];
        let orderno = paramlist['roleId'] + "_" + curtime;
        let roleid = paramlist['roleId'];
        let savevalue = paramlist['saveValue'];
        if (itemid >= 1000){
            savevalue = 1;
        }

        let itemData = {
            "orderno": orderno, //xx
            "serverid": serverId, //xx
            "orderno":orderno,
            "openid": this.mopenid, //xx
            "roleid":roleid, //xx
            "itemid":itemid,
            "savevalue":savevalue,
            "amount":amount,
            "itemname": itemname, //xx
            "cpmsg":cpmsg,
        };

        allusdk_payOne(itemData, this.payCallback);
        return true;
    }

    reportRoleCreate(serverInfo, roleinfo){
        TLog.Debug("AlluGameSdk::reportRoleCreate");
        if (this.minit != true) {
            return false;
        }
        if (this.cheat){
            return true
        }
        let zoneid = serverInfo.id + 1
        if (serverInfo.gameId <= 1000 && serverInfo.gameId != 202){
            return true
        }

        //zoneid = zoneid - 1000
        //IGlobal.gameSdk.reportRoleCreate(serverInfo.ServerID, serverInfo.ServerName, roleInfo.id, roleInfo.name);
        allusdk_reportRoleCreate(serverInfo, roleinfo, this.mopenid, this.mplatform_id);

        return true;
    }

    reportRoleLogin(serverInfo, roleinfo){
        TLog.Debug("AlluGameSdk::reportRoleLogin");
        if (this.minit != true) {
            return false;
        }
        if (this.cheat){
            return true
        }

        let zoneid = serverInfo.id + 1
        if (serverInfo.gameId <= 1000 && serverInfo.gameId != 202){
            return true
        }
        //zoneid = zoneid - 1000
        //IGlobal.gameSdk.reportRoleLogin(serverInfo.ServerID, serverInfo.ServerName, heroInfo["id"], heroInfo["name"], heroInfo["level"], heroInfo['gold'], heroInfo['force']);
        allusdk_reportRoleLogin(serverInfo, roleinfo, this.mopenid, this.mplatform_id);

        return true;
    }

    reportFirstEnter(){
        TLog.Debug("AlluGameSdk::reportFirstEnter");
        if (this.minit != true) {
            return false;
        }
        if (this.cheat){
            return true
        }
        TLog.Debug("report openid", this.mopenid)
        TLog.Debug("report mplatform_id", this.mplatform_id)
        allusdk_reportFirstEnter(this.mopenid, this.mplatform_id);

        return true;
    }

    reportPayReturn(serverinfo, roleinfo, payInfo){
        TLog.Debug("reportPayReturn")
        TLog.Debug("reportPayReturn payInfo:"+JSON.stringify(payInfo))
        TLog.Debug("reportPayReturn roleinfo:"+JSON.stringify(roleinfo))
        if (payInfo.paytype != null && payInfo.paytype == "yixiu"){
            return true;
        }

        allusdk_reportPay(serverinfo, roleinfo, payInfo, this.mopenid, this.mplatform_id);
        return true;
    }
    
    callSdk(fun, param){
        // TLog.Debug("callSdk fun", fun)
        // TLog.Debug("callSdk param", param)
        if (fun == "OnLevelUp"){
            //let infoParam = "roleId=" + hero.getId() + "&roleName=" + GetHeroProperty("name") + "&roleLevel=" + newLevel + "&gameId=" + recentGameId + "&groupIndex=" + (recentGroupIndex + 1) + "&serverId=" + (serverInfo.id + 1)
            let paramlist = core.GameSdkUtil.splitHttpParams(param);
            // {"identify":"g2460","msg":"msg_get_foucus","data":{"server":"1","roleName":"abc","roleId":"123","level":"999"}}
            let postdata = {}
            postdata.action = "user_level_up";
            postdata.serverid = paramlist.serverId;
            postdata.roleId = paramlist.roleId;
            postdata.roleName = paramlist.roleName;
            postdata.level = paramlist.roleLevel;

            TLog.Debug("user_level_up post", JSON.stringify(postdata))
            allusdk_postMessage(postdata);
        }else if (fun == "GameLog"){
            let paramsStr = param + "&openid=" + this.mopenid + "&appid=" + this.mappid;
            this.sendHttp(this.gamelogurl+"?"+paramsStr, 0)
        }else if (fun == "SwitchAccount"){
        	let postdata = {};
        	postdata.action = "msg_report";
        	allusdk_postMessage(postdata);
        }else if (fun == "startServerInfo"){
            let postdata = {};
            postdata.action = "start_server_info";
        	allusdk_postMessage(postdata);
        }else{
            egret.ExternalInterface.call(fun, param);
        }

    }
}
window.AlluGameSdk = AlluGameSdk;